// Standardne ANSI-C++ biblioteke
//  - nisu potrebne sve biblioteke za ovaj primjer,
//    ali su dodane radi jedostavnije prilagodne primjera
//    za demonstraciju drugih problema
#include <iostream> // osnovne ulazno-izlazne funkcije
#include <fstream>  // omogucuje zapis u datoteke
#include <iomanip>  // omogucuje podesavanje ispisa
#include <new>      // funkcije za dinamicku pohranu
#include <string>   // string-funkcije
#include <cstdio>   // osnovne ulazno-izlazne C-funkcije
#include <cstdlib>  // razne standardne C-funkcije
#include <cmath>    // osnovne matematicke C-funkcije

using namespace std; // provjeri postojanje objekta u std

#include "ran1.c" // ucitavamo datoteku u kojoj je definiran generator

int main(void) {
	int i;
	long idum = (-2578); // RAN: generatoru u pocetku prosljedjujemo negativni cijeli broj
	string line = "IO_ran1.txt";
	float r;

	ofstream fout(line.c_str()); // datoteka za pohranu
	fout << showpoint << scientific << setprecision(8);
	cout << showpoint << scientific << setprecision(8);
	for (i = 1; i <= 500; i++) {
		r = ran1(&idum);  // RAN: pozivamo gnereator i pohranjujemo generirani broj u varijablu r
		//ispis u datoteku
		fout << setw(7) << i << "  "
			<< setw(13) << r
			<< endl;
		//ispis na ekran
		cout << setw(7) << i << "  "
			<< setw(13) << r
			<< endl;
	}
	fout.close();

	// provjera zapisanih vrijednosti
	ifstream fin(line.c_str()); // datoteka za citanje podataka
	getline(fin, line); // cita cijelu liniju
	idum = (-2578);     // resetiranje generatora
	cout << line << " ?= " << ran1(&idum) << endl; // provjera resetirano-pohranjeno
	while (fin >> i >> r){
		cout << i << "  " << r << " ?= " << ran1(&idum) << endl;
	}
	return 0;
}
